unit ZRPrgres;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
     Dialogs, StdCtrls, ComCtrls, ZRPrntr;

type
  TZRProgressForm = class(TForm)
    Gauge : TProgressBar;
    Info  : TLabel;
    Cancel: TButton;
    procedure CancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    fZRPrinter : TZRPrinter;
  protected
    procedure CMZRPROGRESSUPDATE(var Message); message CM_ZRPROGRESSUPDATE;
  public
    property ZRPrinter : TZRPrinter read fZRPrinter write fZRPrinter;
  end;

implementation

{$R *.DFM}

uses ZRConst;

procedure TZRProgressForm.FormCreate(Sender: TObject);
begin
  Caption       := LoadStr(szrPrinting);
  Cancel.Caption:= LoadStr(szrCancel);
end;

procedure TZRProgressForm.CMZRPROGRESSUPDATE(var Message);
begin
  if (fZRPrinter.Progress mod 5) = 0 then
    begin
      Gauge.Position := fZRPrinter.Progress;
      Info .Caption  := IntToStr(fZRPrinter.Progress)+'% ' + LoadStr(SzrCompleted);
      Application.ProcessMessages;
    end;
end;

procedure TZRProgressForm.CancelClick(Sender: TObject);
begin
  fZRPrinter.Cancel;
end;

end.
